/*
 * Extensive INTERVAL function tests.
 */

DISPLAY "MLS" INTERVAL(2000-12-31T23:59:59+01:01, 2000-12-31T23:59:59-01:01, "milliseconds") SKIP.
DISPLAY "Sec" INTERVAL(2000-12-31T23:59:59+01:01, 2000-12-31T23:59:59-01:01, "seconds") SKIP.
DISPLAY "min" INTERVAL(2000-12-31T23:59:59+01:01, 2000-12-31T23:59:59-01:01, "minute") SKIP.
DISPLAY "hrs" INTERVAL(2000-12-31T23:59:59+01:01, 2000-12-31T23:59:59-01:01, "hours") SKIP.
DISPLAY "day" INTERVAL(2000-12-31T23:59:59+01:01, 2000-12-31T23:59:59-01:01, "day") SKIP.
DISPLAY "wek" INTERVAL(2000-12-31T23:59:59+01:01, 2000-12-31T23:59:59-01:01, "week") SKIP.
DISPLAY "mnt" INTERVAL(2000-10-31T23:59:59+01:01, 2000-12-31T23:59:59-01:01, "months") SKIP.
DISPLAY "mnt" INTERVAL(2000-12-31T23:59:59+01:01, 2000-10-31T23:59:59-01:01, "months") SKIP.
DISPLAY "Yrs" INTERVAL(2001-12-31T23:59:59+01:01, 2000-12-31T23:59:59-01:01, "year") SKIP.
DISPLAY "Yrs" INTERVAL(2000-12-31T23:59:59+01:01, 2001-12-31T23:59:59-01:01, "year") SKIP.


DEFINE VARIABLE b AS CHARACTER EXTENT 81 FORMAT "x(11)".
DEFINE VARIABLE hdr AS CHARACTER.
FORM hdr FORMAT "x(76)" SKIP b WITH NO-LABEL NO-BOX FRAME fr.

DEFINE VARIABLE dd AS DATE EXTENT 9.
ASSIGN
    dd[1] = 12/31/2050
    dd[2] = 10/04/1582
    dd[3] = 10/15/1582
    dd[4] = 01/01/001
    dd[5] = 06/15/1974
    dd[6] = 04/05/-4716
    dd[7] = 05/13/2013
    dd[8] = 01/01/1900
    dd[9] = 05/13/2013.

DEFINE VARIABLE dt AS DATETIME EXTENT 9.
ASSIGN
    dt[1] = 2050-12-31T10:30:21.555
    dt[2] = 1582-10-04T16:48:31.123
    dt[3] = 1582-10-15T00:00:00.000
    dt[4] = 0001-01-01T06:18:20.192
    dt[5] = 1974-06-15T21:45:56.483
    dt[6] = 4716-04-05T12:58:31.000
    dt[7] = 2013-05-13T02:35:40.623
    dt[8] = 1900-01-01T20:06:22.002
    dt[9] = 2013-05-13T15:15:15.155.

DEFINE VARIABLE dz AS DATETIME-TZ EXTENT 9.
ASSIGN
    dz[1] = 2050-12-31T10:30:21.555+10:00
    dz[2] = 1582-10-04T16:48:31.123+03:30
    dz[3] = 1582-10-15T00:00:00.000-02:00
    dz[4] = 0001-01-01T06:18:20.192-06:00
    dz[5] = 1974-06-15T21:45:56.483+00:00
    dz[6] = 4716-04-05T12:58:31.000+07:45
    dz[7] = 2013-05-13T02:35:40.623+04:00
    dz[8] = 1900-01-01T20:06:22.002-06:00
    dz[9] = 2013-05-13T15:15:15.155-01:30.


FUNCTION run-test-dd RETURN LOGICAL (INPUT unit AS CHARACTER):
   DEFINE VARIABLE i AS INT.
   DEFINE VARIABLE j AS INT.
   DISPLAY ("DATE 2 DATE " + unit) @ hdr WITH FRAME fr.
   REPEAT i = 0 TO 8:
      REPEAT j = 0 TO 8 :
         /* MESSAGE dd[i + 1] " * " dd[j + 1] " * " dd[i + 1] - dd[j + 1]. */
         DISPLAY STRING(INTERVAL(dd[i + 1], dd[j + 1], unit)) @ b[(i * 9) + j + 1] WITH FRAME fr.
      END.
   END.
END.

FUNCTION run-test-td RETURN LOGICAL (INPUT unit AS CHARACTER):
   DEFINE VARIABLE i AS INT.
   DEFINE VARIABLE j AS INT.
   DISPLAY ("DATETIME 2 DATE " + unit) @ hdr WITH FRAME fr.
   REPEAT i = 0 TO 8:
      REPEAT j = 0 TO 8 :
         DISPLAY STRING(INTERVAL(dt[i + 1], dd[j + 1], unit)) @ b[(i * 9) + j + 1] WITH FRAME fr.
      END.
   END.
END.

FUNCTION run-test-zd RETURN LOGICAL (INPUT unit AS CHARACTER):
   DEFINE VARIABLE i AS INT.
   DEFINE VARIABLE j AS INT.
   DISPLAY ("DATETIME-TZ 2 DATE " + unit) @ hdr WITH FRAME fr.
   REPEAT i = 0 TO 8:
      REPEAT j = 0 TO 8 :
         DISPLAY STRING(INTERVAL(dz[i + 1], dd[j + 1], unit)) @ b[(i * 9) + j + 1] WITH FRAME fr.
      END.
   END.
END.


FUNCTION run-test-dt RETURN LOGICAL (INPUT unit AS CHARACTER):
   DEFINE VARIABLE i AS INT.
   DEFINE VARIABLE j AS INT.
   DISPLAY ("DATE 2 DATETIME " + unit) @ hdr WITH FRAME fr.
   REPEAT i = 0 TO 8:
      REPEAT j = 0 TO 8 :
         DISPLAY STRING(INTERVAL(dd[i + 1], dt[j + 1], unit)) @ b[(i * 9) + j + 1] WITH FRAME fr.
      END.
   END.
END.

FUNCTION run-test-tt RETURN LOGICAL (INPUT unit AS CHARACTER):
   DEFINE VARIABLE i AS INT.
   DEFINE VARIABLE j AS INT.
   DISPLAY ("DATETIME 2 DATETIME " + unit) @ hdr WITH FRAME fr.
   REPEAT i = 0 TO 8:
      REPEAT j = 0 TO 8 :
         DISPLAY STRING(INTERVAL(dt[i + 1], dt[j + 1], unit)) @ b[(i * 9) + j + 1] WITH FRAME fr.
      END.
   END.
END.

FUNCTION run-test-zt RETURN LOGICAL (INPUT unit AS CHARACTER):
   DEFINE VARIABLE i AS INT.
   DEFINE VARIABLE j AS INT.
   DISPLAY ("DATETIME-TZ 2 DATETIME " + unit) @ hdr WITH FRAME fr.
   REPEAT i = 0 TO 8:
      REPEAT j = 0 TO 8 :
         DISPLAY STRING(INTERVAL(dz[i + 1], dt[j + 1], unit)) @ b[(i * 9) + j + 1] WITH FRAME fr.
      END.
   END.
END.


FUNCTION run-test-dz RETURN LOGICAL (INPUT unit AS CHARACTER):
   DEFINE VARIABLE i AS INT.
   DEFINE VARIABLE j AS INT.
   DISPLAY ("DATE 2 DATETIME-TZ " + unit) @ hdr WITH FRAME fr.
   REPEAT i = 0 TO 8:
      REPEAT j = 0 TO 8 :
         DISPLAY STRING(INTERVAL(dd[i + 1], dz[j + 1], unit)) @ b[(i * 9) + j + 1] WITH FRAME fr.
      END.
   END.
END.

FUNCTION run-test-tz RETURN LOGICAL (INPUT unit AS CHARACTER):
   DEFINE VARIABLE i AS INT.
   DEFINE VARIABLE j AS INT.
   DISPLAY ("DATETIME 2 DATETIME-TZ " + unit) @ hdr WITH FRAME fr.
   REPEAT i = 0 TO 8:
      REPEAT j = 0 TO 8 :
         DISPLAY STRING(INTERVAL(dt[i + 1], dz[j + 1], unit)) @ b[(i * 9) + j + 1] WITH FRAME fr.
      END.
   END.
END.

FUNCTION run-test-zz RETURN LOGICAL (INPUT unit AS CHARACTER):
   DEFINE VARIABLE i AS INT.
   DEFINE VARIABLE j AS INT.
   DISPLAY ("DATETIME-TZ 2 DATETIME-TZ " + unit) @ hdr WITH FRAME fr.
   REPEAT i = 0 TO 8:
      REPEAT j = 0 TO 8 :
         DISPLAY STRING(INTERVAL(dz[i + 1], dz[j + 1], unit)) @ b[(i * 9) + j + 1] WITH FRAME fr.
      END.
   END.
END.

DEFINE VARIABLE units AS CHARACTER EXTENT 8 INITIAL ["milliseconds", "second", 
               "minutes", "hours", "days", "weeks", "months", "years"].

DEFINE VARIABLE it AS INT.
REPEAT it = 1 TO 7:
   MESSAGE "Press space to see " + units[it] + " intervals:".
   PAUSE. run-test-dd(units[it]).
   PAUSE. run-test-td(units[it]).
   PAUSE. run-test-zd(units[it]).

   PAUSE. run-test-dt(units[it]).
   PAUSE. run-test-tt(units[it]).
   PAUSE. run-test-zt(units[it]).

   PAUSE. run-test-dz(units[it]).
   PAUSE. run-test-tz(units[it]).
   PAUSE. run-test-zz(units[it]).
END.

