SESSION:DATE-FORMAT = "mdy".

DISPLAY "Edge datetime add-intervals" WITH NO-BOX.
FUNCTION add-datetime RETURN LOGICAL 
    (INPUT d AS DATETIME, 
     INPUT amount AS INT,
     INPUT unit AS CHARACTER,
     INPUT expected AS DATETIME):
    
    DEFINE VARIABLE d2 AS DATETIME.
    DEFINE VARIABLE buff AS CHARACTER FORMAT "x(76)".
    DEFINE VARIABLE ret AS LOGICAL INIT TRUE.
    d2 = ADD-INTERVAL(d, amount, unit).

    buff = STRING(d2) + " " + STRING(expected).
    IF d2 EQ expected THEN DO: 
        buff = buff + " .. Ok!".
    END.
    ELSE DO:
        buff = buff + " Failed! ..".
        ret = NO.
    END.
    DISPLAY buff WITH NO-BOX NO-LABEL.
    IF (NOT ret) THEN
        PAUSE MESSAGE "Failed .....".
    RETURN ret.
END.

DEFINE VAR dt AS DATETIME.
dt = NOW.
add-datetime(dt, 10, "week", ADD-INTERVAL(dt, 70, "days")).
add-datetime(dt, 1000, "milliseconds", ADD-INTERVAL(dt, 1, "seconds")).
add-datetime(dt, 120, "minutes", ADD-INTERVAL(dt, 2, "hours")).
add-datetime(dt, 2, "days", ADD-INTERVAL(dt, 48, "hours")).
add-datetime(dt, 2, "years", ADD-INTERVAL(dt, 24, "month")).

dt = 1974-06-14T12:34:56.789.
add-datetime(dt, +812, "millisecond", 1974-06-14T12:34:57.601).
add-datetime(dt, +7,   "second",      1974-06-14T12:35:03.789).
add-datetime(dt, +654, "minute",      1974-06-14T23:28:56.789).
add-datetime(dt, +38,  "hour",        1974-06-16T02:34:56.789).
add-datetime(dt, +1,   "day",         1974-06-15T12:34:56.789).
add-datetime(dt, +1,   "week",        1974-06-21T12:34:56.789).
add-datetime(dt, +1,   "month",       1974-07-14T12:34:56.789).
add-datetime(dt, +1,   "year",        1975-06-14T12:34:56.789).

add-datetime(dt, -812, "millisecond", 1974-06-14T12:34:55.977).
add-datetime(dt, -7,   "second",      1974-06-14T12:34:49.789).
add-datetime(dt, -654, "minute",      1974-06-14T01:40:56.789).
add-datetime(dt, -38,  "hour",        1974-06-12T22:34:56.789).
add-datetime(dt, -1,   "day",         1974-06-13T12:34:56.789).
add-datetime(dt, -1,   "week",        1974-06-07T12:34:56.789).
add-datetime(dt, -1,   "month",       1974-05-14T12:34:56.789).
add-datetime(dt, -1,   "year",        1973-06-14T12:34:56.789).

dt = 1582-10-04T12:34:56.789.
add-datetime(dt, +38,  "hour",        1582-10-16T02:34:56.789).
add-datetime(dt, +1,   "day",         1582-10-15T12:34:56.789).
add-datetime(dt, +1,   "week",        1582-10-21T12:34:56.789).
add-datetime(dt, +1,   "month",       1582-11-14T12:34:56.789). /* 1582-11-04T12:34:56.789 */
add-datetime(dt, +1,   "year",        1583-10-14T12:34:56.789). /* 1583-10-04T12:34:56.789 */

add-datetime(dt, -38,  "hour",        1582-10-02T22:34:56.789).
add-datetime(dt, -1,   "day",         1582-10-03T12:34:56.789).
add-datetime(dt, -1,   "week",        1582-09-27T12:34:56.789).
add-datetime(dt, -1,   "month",       1582-09-04T12:34:56.789).
add-datetime(dt, -1,   "year",        1581-10-04T12:34:56.789).

dt = 1582-10-15T12:34:56.789.
add-datetime(dt, +38,  "hour",        1582-10-17T02:34:56.789).
add-datetime(dt, +1,   "day",         1582-10-16T12:34:56.789).
add-datetime(dt, +1,   "week",        1582-10-22T12:34:56.789).
add-datetime(dt, +1,   "month",       1582-11-15T12:34:56.789).
add-datetime(dt, +1,   "year",        1583-10-15T12:34:56.789).

add-datetime(dt, -38,  "hour",        1582-10-03T22:34:56.789).
add-datetime(dt, -1,   "day",         1582-10-04T12:34:56.789).
add-datetime(dt, -1,   "week",        1582-09-28T12:34:56.789).
add-datetime(dt, -1,   "month",       1582-09-15T12:34:56.789).
add-datetime(dt, -1,   "year",        1581-10-15T12:34:56.789).
