/* DISPLAY DATETIME-TZ("31-07-2013 22:15:23.400"). */

DEFINE VARIABLE cnt AS INTEGER INIT 0 LABEL "Test #".
DEFINE VARIABLE que AS CHARACTER LABEL "Query" FORMAT "x(50)". 
DEFINE TEMP-TABLE tt1
   FIELD i    AS INTEGER
   FIELD d    AS DATE
   FIELD dt   AS DATETIME
   FIELD dtz  AS DATETIME-TZ
   FIELD dd   AS DATE        EXTENT 2
   FIELD ddt  AS DATETIME    EXTENT 2
   FIELD ddtz AS DATETIME-TZ EXTENT 2.

FORM cnt SKIP que SKIP
      tt1.i SKIP
      tt1.d SKIP tt1.dt SKIP tt1.dtz SKIP 
      tt1.dd[1] SKIP tt1.dd[2] SKIP
      tt1.ddt[1] SKIP tt1.ddt[2] SKIP
      tt1.ddtz[1] SKIP tt1.ddtz[2]
   WITH SIDE-LABELS FRAME ff1.

DEFINE VARIABLE now0 AS DATETIME-TZ INIT NOW.
DEFINE VARIABLE ix AS INTEGER NO-UNDO.

CREATE tt1.
ASSIGN
   tt1.i = ?
   tt1.d = TODAY
   tt1.dt = NOW
   tt1.dtz = now0
   tt1.dd[2] = 10/10/2010
   tt1.ddt[2] = 2013-05-21t12:34:56.789
   tt1.ddtz[2] = 2013-05-21t12:34:56.789+10:00.

FUNCTION prin-t RETURNS LOGICAL (INPUT ch AS CHARACTER):
   IF AVAILABLE(tt1) THEN DO:
      DISPLAY tt1 WITH FRAME ff1.
      cnt = cnt + 1.
      DISPLAY cnt ch @ que WITH FRAME ff1.
   END.
   ELSE
      MESSAGE "Record not found for query: " + ch.

      IF ERROR-STATUS:ERROR OR ERROR-STATUS:NUM-MESSAGES > 0 THEN DO:
         DO ix = 1 TO ERROR-STATUS:NUM-MESSAGES:
            MESSAGE ERROR-STATUS:GET-NUMBER(ix) ERROR-STATUS:GET-MESSAGE(ix).
         END.
      END.
END.


FIND FIRST tt1 WHERE d NE DATE("15-06-74") NO-ERROR.
prin-t("d NE DATE('15-06-74'").

FIND FIRST tt1 WHERE i EQ ? NO-ERROR.
prin-t("i EQ ?").

FIND FIRST tt1 WHERE year(dt) gt 2000 NO-ERROR.
prin-t("year(dt) gt 2000").

FIND FIRST tt1 WHERE dtz NE ? NO-ERROR.
prin-t("dtz NE ?").

/* -- timezone(dtz) is not implemented at this time in pl/java 
FIND FIRST tt1 WHERE timezone(dtz) = timezone() NO-ERROR.
prin-t("timezone(dtz) == timezone()").

Function "GETTIMEZONE" not found; SQL statement:
   getTimezone((temprecord0_.dtz_timestamp, temprecord0_.dtz_offset))=getTimezone_1()
*/

/* -- disabled, working only when datetimetz class is mapped to new CompositeCustomType(new DatetimeTzUserType())
FIND FIRST tt1 WHERE dtz = now0 NO-ERROR.
prin-t("dtz = now0").
*/

/* 565 FIND FIRST/LAST failed for table TempRecord1 
FIND FIRST tt1 WHERE dtz NE NOW NO-ERROR.
prin-t("dtz NE now").

Hibernate bug, NE badly expanded:
      temprecord0_.dtz_timestamp<>? and temprecord0_.dtz_offset<>?
instead of: 
      (temprecord0_.dtz_timestamp<>? or temprecord0_.dtz_offset<>?)
*/

/* -- disabled, working only when datetimetz class is mapped to new CompositeCustomType(new DatetimeTzUserType())
FIND FIRST tt1 WHERE (dtz = now0) OR (dtz NE now0) NO-ERROR.
prin-t("(dtz = now0) OR (dtz NE now0)").
*/

/* -- disabled, working only when datetimetz class is mapped to new CompositeCustomType(new DatetimeTzUserType())
FIND FIRST tt1 WHERE (dtz = now0) AND (dtz NE NOW) NO-ERROR.
prin-t("(dtz = now0) AND (dtz NE NOW)").
*/

/* -- disabled, working only when datetimetz class is mapped to new CompositeCustomType(new DatetimeTzUserType())
FIND FIRST tt1 WHERE dtz NE now0 NO-ERROR.
prin-t("dtz NE now0").
*/

FIND FIRST tt1 WHERE ddtz[1] EQ ? NO-ERROR.
prin-t("ddtz[1] EQ ?").

FIND FIRST tt1 WHERE ddtz[2] NE dtz NO-ERROR.
prin-t("ddtz[2] NE dtz").

/* -- disabled, working only when datetimetz class is mapped to new CompositeCustomType(new DatetimeTzUserType())
FIND FIRST tt1 WHERE ddtz[2] NE now0 NO-ERROR.
prin-t("ddtz[2] NE now0").
*/

FIND FIRST tt1 WHERE i EQ ? NO-ERROR.
prin-t("i EQ ?").

FIND FIRST tt1 WHERE INT64(d) GT 1000 NO-ERROR.
prin-t("INT64(d) GT 1000").

FIND FIRST tt1 WHERE d EQ TODAY NO-ERROR.
prin-t("d EQ TODAY").

FIND FIRST tt1 WHERE d NE DATE(10, 10, 10) NO-ERROR.
prin-t("d NE DATE(10, 10, 10)").

FIND FIRST tt1 WHERE d EQ DATE(INT64(d)) NO-ERROR.
prin-t("d EQ DATE(INT64(d))").

FIND FIRST tt1 WHERE d GT 03/16/1999 NO-ERROR.
prin-t("d GT 03/16/1999").

FIND FIRST tt1 WHERE ADD-INTERVAL(d, 6, "days") GE TODAY NO-ERROR.
prin-t("ADD-INTERVAL(d, 6, 'days') GE TODAY").

FIND FIRST tt1 WHERE ADD-INTERVAL(dt, 6, "milliseconds") GE dt NO-ERROR.
prin-t("ADD-INTERVAL(dt, 6, 'milliseconds') GE dt").

FIND FIRST tt1 WHERE INTERVAL(d, 03/16/1999, "days") NE 5 NO-ERROR.
prin-t("INTERVAL(d, 03/16/1999, 'days') NE 5").

FIND FIRST tt1 WHERE INTERVAL(dt, 03/16/1999, "milliseconds") GT 3000000000 NO-ERROR.
prin-t("INTERVAL(dt, 03/16/1999, 'milliseconds') GT 3000000000").

FIND FIRST tt1 WHERE dt GT DATETIME(10, 10, 10, 10, 10) NO-ERROR.
prin-t("dt GT DATETIME(10, 10, 10, 10, 10)").

FIND FIRST tt1 WHERE MTIME(dt) NE MTIME NO-ERROR.
prin-t("MTIME(dt) NE MTIME").

/* -- disabled, working only when datetimetz class is mapped to new CompositeCustomType(new DatetimeTzUserType())
FIND FIRST tt1 WHERE dtz NE DATETIME-TZ("12/31/2013 10:20:30.400") NO-ERROR.
prin-t('dtz NE DATETIME-TZ("2013/12/31 10:20:30.400")').
*/

FIND FIRST tt1 WHERE dt EQ DATETIME(STRING(dt)) NO-ERROR.
prin-t('dt EQ DATETIME(STRING(dt))').

/* toDatetimeTz() / toString(datetimetz)  are not implemented at this moment in pl/java
FIND FIRST tt1 WHERE dtz EQ DATETIME-TZ(STRING(dtz)) NO-ERROR.
prin-t('dtz EQ DATETIME-TZ(STRING(dtz))').

   tt1.dtz = toDatetimeTz(toString(tt1.dtz))
*/

FIND FIRST tt1 WHERE 2013-01-13t20:34:56.776 LT dt NO-ERROR.
prin-t("dt LT 2013-01-13t20:34:56.776").

/* -- disabled, working only when datetimetz class is mapped to new CompositeCustomType(new DatetimeTzUserType())
FIND FIRST tt1 WHERE dtz <= NOW NO-ERROR.
prin-t("dtz <= NOW"). 
*/

FIND FIRST tt1 WHERE YEAR(dd[2]) EQ 2010 NO-ERROR.
prin-t("YEAR(dd[2]) EQ 2010").

FIND FIRST tt1 WHERE dd[1] EQ ? NO-ERROR.
prin-t("dd[1] EQ ?").

FIND FIRST tt1 WHERE MONTH(ddt[2]) > 3 NO-ERROR.
prin-t("MONTH(ddt[2]) > 3").

FIND FIRST tt1 WHERE DAY(ddt[2]) NE 11 NO-ERROR.
prin-t("DAY(ddt[2]) NE 11").

FIND FIRST tt1 WHERE (d - TODAY) LT 2 NO-ERROR.
prin-t("(d - TODAY) LT 2").

FIND FIRST tt1 WHERE (dt - NOW) / 1000 LT 5 NO-ERROR.
prin-t("(dt - NOW) / 1000 LT 5").

/* Function "DIVIDE" not found; SQL statement
FIND FIRST tt1 WHERE (dtz - NOW) / 1000 LT 5 NO-ERROR.
prin-t("(dtz - NOW) / 1000 LT 5").

   Function "DIVIDE" not found; SQL statement
   divide(timeSpan((temprecord0_.dtz_timestamp, temprecord0_.dtz_offset), ?), 1000)<5
*/

/* -- disabled, working only when datetimetz class is mapped to new CompositeCustomType(new DatetimeTzUserType())
FIND FIRST tt1 WHERE dtz NE 2013-01-13t20:34:56.776+03:00 NO-ERROR.
prin-t("dtz NE 2013-01-13t20:34:56.776+03:00").
   /*
      if your TIMEZONE is +03:00, (dtz NE 2013-01-13t20:34:56.776+03:00) 
      will fail because of dtz expansion to 'AND' instead of 'OR'
   */
*/


