DEFINE TEMP-TABLE tt
    FIELD x AS LOGICAL.

CREATE tt.
FIND FIRST tt.

DEFINE VARIABLE vRaw AS RAW NO-UNDO.
vRaw = BASE64-DECODE("020002abcdef").

FUNCTION get-character1 RETURNS CHARACTER:   RETURN "12/12/12 10:10+1". END FUNCTION.
FUNCTION get-character2 RETURNS CHARACTER:   RETURN "QQQ".              END FUNCTION.
FUNCTION get-longchar   RETURNS LONGCHAR:    RETURN "10/10/10 11:1+2".  END FUNCTION.
FUNCTION get-int        RETURNS INT:         RETURN 2460000.            END FUNCTION. /* 23-02-2023*/
FUNCTION get-long64     RETURNS INT64:       RETURN 2450000.            END FUNCTION. /* 08.10.1995 */
FUNCTION get-decimal    RETURNS DECIMAL:     RETURN 2440000.9.          END FUNCTION. /* 23.15.1968 */
FUNCTION get-logical    RETURNS LOGICAL:     RETURN YES.                END FUNCTION.
FUNCTION get-raw        RETURNS RAW:         RETURN vRaw.               END FUNCTION.
FUNCTION get-memptr     RETURNS MEMPTR:      RETURN BASE64-DECODE("020002abcdef"). END FUNCTION.
FUNCTION get-rowid      RETURNS ROWID:       RETURN TO-ROWID("0x02").   END FUNCTION.
FUNCTION get-date       RETURNS DATE:        RETURN TODAY.              END FUNCTION.
FUNCTION get-datetime   RETURNS DATETIME:    RETURN NOW.                END FUNCTION.
FUNCTION get-datetimetz RETURNS DATETIME-TZ: RETURN NOW + 1000.         END FUNCTION.
FUNCTION get-recid      RETURNS RECID:       RETURN RECID(tt).          END FUNCTION.
FUNCTION get-handle     RETURNS HANDLE:      RETURN BUFFER tt:HANDLE.   END FUNCTION.
FUNCTION get-unknown1   RETURNS DATE:        RETURN ?.                  END FUNCTION.
FUNCTION get-unknown2   RETURNS RAW:         RETURN ?.                  END FUNCTION.
FUNCTION get-unknown3   RETURNS DATE:        RETURN ?.                  END FUNCTION.

DEFINE VARIABLE d AS DATE.
DEFINE VARIABLE dt AS DATETIME.
DEFINE VARIABLE dtz AS DATETIME-TZ.

/* */
d = TODAY.
dt = NOW.
dtz = NOW.

DISPLAY d dt dtz SKIP WITH SIDE-LABELS NO-BOX.
PAUSE MESSAGE "Now/today datetime/tz".


/*
DEFINE VARIABLE d1 AS DATE EXTENT 18 NO-UNDO.
d1[ 1] = DYNAMIC-FUNCTION("get-character1").
d1[ 2] = DYNAMIC-FUNCTION("get-character2") NO-ERROR. 
d1[ 3] = DYNAMIC-FUNCTION("get-longchar"). 
d1[ 4] = DYNAMIC-FUNCTION("get-int").      
d1[ 5] = DYNAMIC-FUNCTION("get-long64").
d1[ 6] = DYNAMIC-FUNCTION("get-decimal").           
d1[ 7] = DYNAMIC-FUNCTION("get-logical").  /* 01.01.-4713, true = 1, false = 0 */
d1[ 8] = DYNAMIC-FUNCTION("get-raw") NO-ERROR. 
d1[ 9] = DYNAMIC-FUNCTION("get-memptr") NO-ERROR.
d1[10] = DYNAMIC-FUNCTION("get-rowid") NO-ERROR.       
d1[11] = DYNAMIC-FUNCTION("get-date"). 
d1[12] = DYNAMIC-FUNCTION("get-datetime").
d1[13] = DYNAMIC-FUNCTION("get-datetimetz"). 
d1[14] = DYNAMIC-FUNCTION("get-recid").   /* treat as integer */ 
d1[15] = DYNAMIC-FUNCTION("get-unknown1").
d1[16] = DYNAMIC-FUNCTION("get-unknown2").
d1[17] = DYNAMIC-FUNCTION("get-handle"). /* treat as integer */ 
d1[18] = DYNAMIC-FUNCTION("---") NO-ERROR.
DISPLAY "DATE dynamically _POLY assigned:" SKIP d1 SKIP WITH SIDE-LABELS.

DEFINE VARIABLE d2 AS DATE EXTENT 17 NO-UNDO.
d2[1] = DATE("10/10/2010").
d2[2] = DATE("qqqq") NO-ERROR.
d2[3] = DATE(get-longchar()).
d2[4] = DATE(100).
d2[5] = DATE(INT64(3000000000)).
/* d2[6] = DATE(999.0)      -- non 4GL */
/* d2[7] = DATE(YES)        -- non 4GL */
/* d2[8] = DATE(get-raw())  -- non 4GL */
/* d2[9] = DATE(get-memptr()).  -- non 4GL */
/* d2[10] = DATE(get-rowid()).  -- non 4GL */
d2[11] = DATE(today).
d2[12] = DATE(now). 
d2[13] = DATE(get-datetimetz()).
/* d2[14] = DATE(get-recid()).  -- non 4GL */
/* d2[15] = DATE(?).            -- non 4GL */
/* d2[16] = DATE(get-handle()). -- non 4GL */
d2[17] = DATE(11, 13, 2014).
DISPLAY "DATE assign using DATE function:" SKIP d2 SKIP.





DEFINE VARIABLE dt1 AS DATETIME EXTENT 18 NO-UNDO.
dt1[ 1] = DYNAMIC-FUNCTION("get-character1").
dt1[ 2] = DYNAMIC-FUNCTION("get-character2") NO-ERROR.
dt1[ 3] = DYNAMIC-FUNCTION("get-longchar") NO-ERROR.
dt1[ 4] = DYNAMIC-FUNCTION("get-int") NO-ERROR.
dt1[ 5] = DYNAMIC-FUNCTION("get-long64") NO-ERROR.
dt1[ 6] = DYNAMIC-FUNCTION("get-decimal") NO-ERROR.
dt1[ 7] = DYNAMIC-FUNCTION("get-logical") NO-ERROR.
dt1[ 8] = DYNAMIC-FUNCTION("get-raw") NO-ERROR.
dt1[ 9] = DYNAMIC-FUNCTION("get-memptr") NO-ERROR.
dt1[10] = DYNAMIC-FUNCTION("get-rowid") NO-ERROR. 
dt1[11] = DYNAMIC-FUNCTION("get-date").
dt1[12] = DYNAMIC-FUNCTION("get-datetime").
dt1[13] = DYNAMIC-FUNCTION("get-datetimetz").     
dt1[14] = DYNAMIC-FUNCTION("get-recid") NO-ERROR.
dt1[15] = DYNAMIC-FUNCTION("get-unknown1"). 
dt1[16] = DYNAMIC-FUNCTION("get-unknown2").
dt1[17] = DYNAMIC-FUNCTION("get-handle") NO-ERROR. 
dt1[18] = DYNAMIC-FUNCTION("---") NO-ERROR.
DISPLAY "DATETIME dynamically _POLY assigned:" SKIP dt1 SKIP WITH SIDE-LABELS.

DEFINE VARIABLE dt2 AS DATETIME EXTENT 20 NO-UNDO.
dt2[1] = DATETIME("14-10-1999 1:32 Pm").
dt2[2] = DATETIME("qqqq") NO-ERROR.
dt2[3] = DATETIME(get-longchar()).
/* dt2[4] = DATETIME(100).                  -- non 4GL */
/* dt2[5] = DATETIME(INT64(3000000000)).    -- non 4GL */
/* dt2[6] = DATETIME(999.0).                -- non 4GL */
/* dt2[7] = DATETIME(YES).                  -- non 4GL */
/* dt2[8] = DATETIME(get-raw())             -- non 4GL */
/* dt2[9] = DATETIME(get-memptr()).         -- non 4GL */
/* dt2[10] = DATETIME(get-rowid()).         -- non 4GL */
dt2[11] = DATETIME(TODAY).
/* dt2[12] = DATETIME(NOW).                 -- non 4GL */
/* dt2[13] = DATETIME(get-datetime()).    -- non 4GL */
/* dt2[14] = DATETIME(get-recid()).         -- non 4GL */
/* dt2[15] = DATETIME(?).                   -- non 4GL */
/* dt2[16] = DATETIME(get-handle()).        -- non 4GL */
dt2[17] = DATETIME(TODAY, INT64(100)).
dt2[18] = DATETIME(12, 31, 1999, 21, 59).
dt2[19] = DATETIME(12, 31, 1999, 21, 59, 58).
dt2[20] = DATETIME(12, 31, 1999, 21, 59, 58, 999).
DISPLAY "DATETIME assign using DATETIME function:" SKIP dt2 SKIP.
*/


DEFINE VARIABLE dtz1 AS DATETIME-TZ EXTENT 18 NO-UNDO.
dtz1[ 1] = DYNAMIC-FUNCTION("get-character1").
dtz1[ 2] = DYNAMIC-FUNCTION("get-character2") NO-ERROR.
dtz1[ 3] = DYNAMIC-FUNCTION("get-longchar").
dtz1[ 4] = DYNAMIC-FUNCTION("get-int") NO-ERROR.
dtz1[ 5] = DYNAMIC-FUNCTION("get-long64") NO-ERROR.
dtz1[ 6] = DYNAMIC-FUNCTION("get-decimal") NO-ERROR.
dtz1[ 7] = DYNAMIC-FUNCTION("get-logical") NO-ERROR.
dtz1[ 8] = DYNAMIC-FUNCTION("get-raw") NO-ERROR.
dtz1[ 9] = DYNAMIC-FUNCTION("get-memptr") NO-ERROR.
dtz1[10] = DYNAMIC-FUNCTION("get-rowid") NO-ERROR.
dtz1[11] = DYNAMIC-FUNCTION("get-date").
dtz1[12] = DYNAMIC-FUNCTION("get-datetime").
dtz1[13] = DYNAMIC-FUNCTION("get-datetimetz").
dtz1[14] = DYNAMIC-FUNCTION("get-recid") NO-ERROR.
dtz1[15] = DYNAMIC-FUNCTION("get-unknown1").
dtz1[16] = DYNAMIC-FUNCTION("get-unknown2").
dtz1[17] = DYNAMIC-FUNCTION("get-handle")  NO-ERROR.
dtz1[18] = DYNAMIC-FUNCTION("---") NO-ERROR.
DISPLAY "DATETIME-TZ dynamically _POLY assigned:" SKIP dtz1 SKIP WITH SIDE-LABELS.


DEFINE VARIABLE dtz2 AS DATETIME-TZ EXTENT 24 NO-UNDO.
dtz2[1] = DATETIME-TZ("12-12-25").
dtz2[2] = DATETIME-TZ("qqqq") NO-ERROR.
dtz2[3] = DATETIME-TZ(get-longchar()).
/* dtz2[4] = DATETIME-TZ(100).                  -- non 4GL */
/* dtz2[5] = DATETIME-TZ(INT64(3000000000)).    -- non 4GL */
/* dtz2[6] = DATETIME-TZ(999.0).                -- non 4GL */
/* dtz2[7] = DATETIME-TZ(YES).                  -- non 4GL */
/* dtz2[8] = DATETIME-TZ(get-raw()) .            -- non 4GL */       
/* dtz2[9] = DATETIME-TZ(get-memptr()).         -- non 4GL */
/* dtz2[10] = DATETIME-TZ(get-rowid()).         -- non 4GL */
dtz2[11] = DATETIME-TZ(TODAY).
dtz2[12] = DATETIME-TZ(NOW). 
dtz2[13] = DATETIME-TZ(get-DATETIMEtz()).
/* dtz2[14] = DATETIME-TZ(get-recid()).         -- non 4GL */
dtz2[15] = DATETIME-TZ(?).
/* dtz2[16] = DATETIME-TZ(get-handle()).        -- non 4GL */
dtz2[17] = DATETIME-TZ(TODAY, INT64(100)).
dtz2[18] = DATETIME-TZ(TODAY, MTIME, TIMEZONE).
dtz2[19] = DATETIME-TZ(NOW, TIMEZONE).
dtz2[20] = DATETIME-TZ(get-datetimetz(), TIMEZONE).
dtz2[21] = DATETIME-TZ(12, 31, 1999, 21, 59).
dtz2[22] = DATETIME-TZ(12, 31, 1999, 21, 59, 58).
dtz2[23] = DATETIME-TZ(12, 31, 1999, 21, 59, 58, 999).
dtz2[24] = DATETIME-TZ(12, 31, 1999, 21, 59, 58, 999, TIMEZONE).

DISPLAY "DATETIME-TZ assign using DATETIME-TZ function:" SKIP dtz2 SKIP  WITH SIDE-LABELS.



/* Expected output:
d: 08/05/13 dt: 08/05/2013 15:43:11.265 dtz: 08/05/2013 15:43:11.265+01:00

DATE dynamically _POLY assigned:
d1[1]: 12/12/12   d1[2]:            d1[3]: 10/10/10   d1[4]: 23/02/23
d1[5]: 08/10/95   d1[6]: 23/05/68   d1[7]: ????????   d1[8]:
d1[9]:            d1[10]:           d1[11]: 08/05/13  d1[12]: 08/05/13 
d1[13]: 08/05/13  d1[14]: ????????  d1[15]:           d1[16]:
d1[17]: ????????  d1[18]:

DATE assign using DATE function:
d2[1]: 10/10/10   d2[2]:            d2[3]: 10/10/10   d2[4]: ???????? 
d2[5]: ????????   d2[6]:            d2[7]:            d2[8]:
d2[9]:            d2[10]:           d2[11]: 08/05/13  d2[12]: 08/05/13 
d2[13]: 08/05/13  d2[14]:           d2[15]:           d2[16]:
d2[17]: 13/11/14

DATETIME dynamically _POLY assigned:
dt1[1]: 12/12/2012 00:00:00.000  dt1[2]:                          dt1[3]: 10/10/2010 00:00:00.000
dt1[4]:                          dt1[5]:                          dt1[6]:
dt1[7]:                          dt1[8]:                          dt1[9]:
dt1[10]:                         dt1[11]: 08/05/2013 00:00:00.000 dt1[12]: 08/05/2013 15:43:33.956
dt1[13]: 08/05/2013 15:43:34.956 dt1[14]:                         dt1[15]:
dt1[16]:                         dt1[17]:                         dt1[18]:

DATETIME assign using DATETIME function:
dt2[1]: 14/10/1999 13:32:00.000  dt2[2]:                          dt2[3]: 10/10/2010 00:00:00.000
dt2[4]:                          dt2[5]:                          dt2[6]:
dt2[7]:                          dt2[8]:                          dt2[9]:
dt2[10]:                         dt2[11]: 08/05/2013 00:00:00.000 dt2[12]:
dt2[13]:                         dt2[14]:                         dt2[15]:
dt2[16]:                         dt2[17]: 08/05/2013 00:00:00.100 dt2[18]: 31/12/1999 21:59:00.000
dt2[19]: 31/12/1999 21:59:58.000 dt2[20]: 31/12/1999 21:59:58.999

DATETIME-TZ dynamically _POLY assigned:
dtz1[1]: 12/12/2012 00:00:00.000+00:00    dtz1[2]:
dtz1[3]: 10/10/2010 00:00:00.000+01:00    dtz1[4]:
dtz1[5]:                                  dtz1[6]:
dtz1[7]:                                  dtz1[8]:
dtz1[9]:                                  dtz1[10]:
dtz1[11]: 08/05/2013 00:00:00.000+01:00   dtz1[12]: 08/05/2013 15:43:33.964+01:00
dtz1[13]: 08/05/2013 15:43:34.964+01:00   dtz1[14]:
dtz1[15]:                                 dtz1[16]:
dtz1[17]:                                 dtz1[18]:

DATETIME-TZ assign using DATETIME-TZ function:
dtz2[1]: 12/12/2025 00:00:00.000+00:00    dtz2[2]:
dtz2[3]: 10/10/2010 00:00:00.000+01:00    dtz2[4]:
dtz2[5]:                                  dtz2[6]:
dtz2[7]:                                  dtz2[8]:
dtz2[9]:                                  dtz2[10]:
dtz2[11]: 08/05/2013 00:00:00.000+01:00   dtz2[12]: 08/05/2013 15:43:33.968+01:00
dtz2[13]: 08/05/2013 15:43:34.968+01:00   dtz2[14]:
dtz2[15]:                                 dtz2[16]:
dtz2[17]: 08/05/2013 00:00:00.100+01:00   dtz2[18]: 08/05/2013 15:43:33.968+01:00
dtz2[19]: 08/05/2013 15:43:33.968+01:00   dtz2[20]: 08/05/2013 15:43:34.968+01:00 
dtz2[21]: 31/12/1999 21:59:00.000+00:00   dtz2[22]: 31/12/1999 21:59:58.000+00:00 
dtz2[23]: 31/12/1999 21:59:58.999+00:00   dtz2[24]: 31/12/1999 21:59:58.999+01:00

** Value 01/01/-4713 cannot be displayed using 99/99/99. (74)
** Value 09/07/-4696 cannot be displayed using 99/99/99. (74)
** Value 18/11/-4711 cannot be displayed using 99/99/99. (74)
** Value 09/04/-4713 cannot be displayed using 99/99/99. (74)
** Value 01/03/-4662 cannot be displayed using 99/99/99. (74)
** Value ?????? cannot be displayed using 99/99/99. (74)

*/