SESSION:DATE-FORMAT = "mdy".

DISPLAY "Edge datetime-tz add-intervals" WITH NO-BOX.
FUNCTION add-datetimetz RETURN LOGICAL 
    (INPUT d AS DATETIME-TZ, 
     INPUT amount AS INT,
     INPUT unit AS CHARACTER,
     INPUT expected AS DATETIME-TZ):
    
    DEFINE VARIABLE d2 AS DATETIME-TZ.
    DEFINE VARIABLE buff AS CHARACTER FORMAT "x(76)".
    DEFINE VARIABLE ret AS LOGICAL INIT TRUE.
    d2 = ADD-INTERVAL(d, amount, unit).

    buff = STRING(d2) + " " + STRING(expected).
    IF d2 EQ expected THEN DO: 
        buff = buff + " .. Ok!".
    END.
    ELSE DO:
        buff = buff + " Failed! ..".
        ret = NO.
    END.
    DISPLAY buff WITH NO-BOX NO-LABEL.
    IF (NOT ret) THEN
        PAUSE MESSAGE "Failed .....".
    RETURN ret.
END.

DEFINE VAR dtz AS DATETIME-TZ.
dtz = NOW.
add-datetimetz(dtz, 10,   "week",           ADD-INTERVAL(dtz, 70, "days")).
add-datetimetz(dtz, 1000, "milliseconds",   ADD-INTERVAL(dtz, 1,  "seconds")).
add-datetimetz(dtz, 120,  "minutes",        ADD-INTERVAL(dtz, 2,  "hours")).
add-datetimetz(dtz, 2,    "days",           ADD-INTERVAL(dtz, 48, "hours")).
add-datetimetz(dtz, 2,    "years",          ADD-INTERVAL(dtz, 24, "month")).

dtz = 1974-06-14T12:34:56.789-02:30.
add-datetimetz(dtz, +812, "millisecond", 1974-06-14T12:34:57.601-02:30).
add-datetimetz(dtz, +7,   "second",      1974-06-14T12:35:03.789-02:30).
add-datetimetz(dtz, +654, "minute",      1974-06-14T23:28:56.789-02:30).
add-datetimetz(dtz, +38,  "hour",        1974-06-16T02:34:56.789-02:30).
add-datetimetz(dtz, +1,   "day",         1974-06-15T12:34:56.789-02:30).
add-datetimetz(dtz, +1,   "week",        1974-06-21T12:34:56.789-02:30).
add-datetimetz(dtz, +1,   "month",       1974-07-14T12:34:56.789-02:30).
add-datetimetz(dtz, +1,   "year",        1975-06-14T12:34:56.789-02:30).

add-datetimetz(dtz, -812, "millisecond", 1974-06-14T12:34:55.977-02:30).
add-datetimetz(dtz, -7,   "second",      1974-06-14T12:34:49.789-02:30).
add-datetimetz(dtz, -654, "minute",      1974-06-14T01:40:56.789-02:30).
add-datetimetz(dtz, -38,  "hour",        1974-06-12T22:34:56.789-02:30).
add-datetimetz(dtz, -1,   "day",         1974-06-13T12:34:56.789-02:30).
add-datetimetz(dtz, -1,   "week",        1974-06-07T12:34:56.789-02:30).
add-datetimetz(dtz, -1,   "month",       1974-05-14T12:34:56.789-02:30).
add-datetimetz(dtz, -1,   "year",        1973-06-14T12:34:56.789-02:30).

dtz = 1582-10-04T12:34:56.789-02:30.
add-datetimetz(dtz, +38,  "hour",        1582-10-16T02:34:56.789-02:30).
add-datetimetz(dtz, +1,   "day",         1582-10-15T12:34:56.789-02:30).
add-datetimetz(dtz, +1,   "week",        1582-10-21T12:34:56.789-02:30).
add-datetimetz(dtz, +1,   "month",       1582-11-14T12:34:56.789-02:30). /* 1582-11-04T12:34:56.789-02:30 */
add-datetimetz(dtz, +1,   "year",        1583-10-14T12:34:56.789-02:30). /* 1583-10-04T12:34:56.789-02:30 */

add-datetimetz(dtz, -38,  "hour",        1582-10-02T22:34:56.789-02:30).
add-datetimetz(dtz, -1,   "day",         1582-10-03T12:34:56.789-02:30).
add-datetimetz(dtz, -1,   "week",        1582-09-27T12:34:56.789-02:30).
add-datetimetz(dtz, -1,   "month",       1582-09-04T12:34:56.789-02:30).
add-datetimetz(dtz, -1,   "year",        1581-10-04T12:34:56.789-02:30).

dtz = 1582-10-15T12:34:56.789-02:30.
add-datetimetz(dtz, +38,  "hour",        1582-10-17T02:34:56.789-02:30).
add-datetimetz(dtz, +1,   "day",         1582-10-16T12:34:56.789-02:30).
add-datetimetz(dtz, +1,   "week",        1582-10-22T12:34:56.789-02:30).
add-datetimetz(dtz, +1,   "month",       1582-11-15T12:34:56.789-02:30).
add-datetimetz(dtz, +1,   "year",        1583-10-15T12:34:56.789-02:30).

add-datetimetz(dtz, -38,  "hour",        1582-10-03T22:34:56.789-02:30).
add-datetimetz(dtz, -1,   "day",         1582-10-04T12:34:56.789-02:30).
add-datetimetz(dtz, -1,   "week",        1582-09-28T12:34:56.789-02:30).
add-datetimetz(dtz, -1,   "month",       1582-09-15T12:34:56.789-02:30).
add-datetimetz(dtz, -1,   "year",        1581-10-15T12:34:56.789-02:30).
